/*
   This ESP8266 NodeMCU code was developed by newbiely.com

   This ESP8266 NodeMCU code is made available for public use without any restriction

   For comprehensive instructions and wiring diagrams, please visit:
   https://newbiely.com/tutorials/esp8266/esp8266-control-led-via-bluetooth
*/

#include <SoftwareSerial.h>
const int rxPin = 5;        //RX sul GPIO5
const int txPin = 4;        //TX sul GPIO4
#define RELAY1 0
#define RELAY2 2
#define RELAY3 14
#define RELAY4 12
String data;

int changeVal = 0;   //if cangeVal = "1", relay1on = HIGH; relay1off = LOW; else relay1on = LOW; relay1off = HIGH
//It is useful if you use commercial a relay, which inverted state.
int relay1on;
int relay1off;
int relay2on;
int relay2off;
int relay3on;
int relay3off;
int relay4on;
int relay4off;
int value1;
int value2;
int value3;
int value4;

SoftwareSerial mySerial(rxPin, txPin);   //Impostiamo le porte seriali

void setup() {
  Serial.begin(9600);
  mySerial.begin(9600);

  if (changeVal == 1) {
    relay1on = 1;
    relay1off = 0;
    relay2on = 1;
    relay2off = 0;
    relay3on = 1;
    relay3off = 0;
    relay4on = 1;
    relay4off = 0;
  }
  else {
    relay1on = 0;
    relay1off = 1;
    relay2on = 0;
    relay2off = 1;
    relay3on = 0;
    relay3off = 1;
    relay4on = 0;
    relay4off = 1;
  }
  value1 = relay1off;
  value2 = relay2off;
  value3 = relay3off;
  value4 = relay4off;

  pinMode(RELAY1, OUTPUT); // Configure the ESP8266 pin as a digital output pin
  digitalWrite(RELAY1, relay1off);
  pinMode(RELAY2, OUTPUT);
  digitalWrite(RELAY2, relay2off);
  pinMode(RELAY3, OUTPUT);
  digitalWrite(RELAY3, relay3off);
  pinMode(RELAY4, OUTPUT);
  digitalWrite(RELAY4, relay4off);
}

void loop() {
  int i = 0;
  char ch = 0;
  data = "";
  while (mySerial.available()) {
    delay(10);
    char ch = mySerial.read();
    if (ch == '#')
    {
      break;
    }
    data += ch;
  }

  if (data.length() > 0) {
    Serial.println(data);

    if (data == "OFF1")  {
      digitalWrite(RELAY1, relay1off);  // turn off relay
      Serial.print("RELAY1 is turned OFF");
    } else if (data == "ON1") {
      digitalWrite(RELAY1, relay1on); // turn on relay
      Serial.print("RELAY1 is turned ON");
    }
    if (data == "OFF2")  {
      digitalWrite(RELAY2, relay2off);  // turn off relay
      Serial.print("LED2 is turned OFF");
    } else if (data == "ON2")  {
      digitalWrite(RELAY2, relay2on); // turn on relay
      Serial.print("LED2 is turned ON");
    }
    if (data == "OFF3")  {
      digitalWrite(RELAY3, relay3off);  // turn off relay
      Serial.print("LED3 is turned OFF");
    } else if (data == "ON3")  {
      digitalWrite(RELAY3, relay3on); // turn on relay
      Serial.print("LED3 is turned ON");
    }
    if (data == "OFF4")  {
      digitalWrite(RELAY4, relay4off);  // turn off relay
      Serial.print("LED4 is turned OFF");
    } else if (data == "ON4")  {
      digitalWrite(RELAY4, relay4on); // turn on relay
      Serial.print("LED4 is turned ON");
    }
    if (data == "OFF5")  {
      digitalWrite(RELAY1, relay1off);
      digitalWrite(RELAY2, relay2off);
      digitalWrite(RELAY3, relay3off);  // turn off relay
      digitalWrite(RELAY4, relay4off);
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } else  if (data == "ON5")  {
      digitalWrite(RELAY1, relay1on);
      digitalWrite(RELAY2, relay2on);
      digitalWrite(RELAY3, relay3on); // turn on relay
      digitalWrite(RELAY4, relay4on);
      Serial.print("RELAY1/2/3/4 are turned ON");
    }
    if (data == "OFF6")  {
      digitalWrite(RELAY4, relay4off);
      delay(250);
      digitalWrite(RELAY3, relay3off);
      delay(250);
      digitalWrite(RELAY2, relay3off);
      delay(250);
      digitalWrite(RELAY1, relay1off);  // turn off relay
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } else if (data == "ON6")  {
      digitalWrite(RELAY1, relay1on);
      delay(250);
      digitalWrite(RELAY2, relay2on);
      delay(250);
      digitalWrite(RELAY3, relay3on); // turn on relay
      delay(250);
      digitalWrite(RELAY4, relay4on);
      Serial.print("RELAY1/2/3/4 are turned ON");
      }
    }
  }
